//////////////////////////////////////////////////////////////////////
//Rechteck-Klasse. Hier werden alle Rechteck-Shapes verwaltet:
//Erzeugen, positionieren, phys.Eigenschaften definieren, zeichnen
//////////////////////////////////////////////////////////////////////
class Raute {
  Body body;      
  color c; 
  PolygonShape pS1;
  
  //Konstruktor
  Raute(float x, float y, color pc) {
    c = pc;
    erzeugeBody(new Vec2(x,y));
  }
  
  void entsorgen() {
    box2d.destroyBody(body);
  }
  
   boolean verschwunden() {
    // Position des Objekts bestimmen
    Vec2 position = box2d.getBodyPixelCoord(body);
    // Objekt ist Unterhalb des Fensters?
    if (position.y > height) {
      entsorgen();
      return true;
    }
    return false;
  } 
  
  void erzeugeBody(Vec2 mittelPunkt){   
    //Body-Definition
    BodyDef bD = new BodyDef();      
    bD.type = BodyType.DYNAMIC;  
    
    //Body-Position umrechnen
    bD.position.set(box2d.coordPixelsToWorld(mittelPunkt));   
    body = box2d.createBody(bD);  
    
    //Rauten-Shape
    pS1 = new PolygonShape();
    Vec2[] v = new Vec2[4];  
    v[0] = box2d.vectorPixelsToWorld(new Vec2(20, 0));
    v[1] = box2d.vectorPixelsToWorld(new Vec2(0, 5));
    v[2] = box2d.vectorPixelsToWorld(new Vec2(-20, 0));
    v[3] = box2d.vectorPixelsToWorld(new Vec2(0, -5)); 
    pS1.set(v, v.length);
  
    //Fixture an body erzeugen
    body.createFixture(pS1,1.0);  
    //Geschwindigkeiten des bodys festlegen
    float vX = random(-10,10);
    float vY = random(0,40);
    float vW = random(-20,20);
    body.setLinearVelocity(new Vec2(vX,vY));    
    body.setAngularVelocity(vW);  
  }
   
  void display() {
    // Lage und Winkel in Pixelkoordinaten besorgen
    Vec2 position = box2d.getBodyPixelCoord(body);		
    float winkel = -body.getAngle();//Minuszeichen ist wichtig!
    //Shape zeichnen
    rectMode(CENTER);
    pushMatrix();
    translate(position.x,position.y);		
   	rotate(winkel);  
    fill(c);
    noStroke();
     
    beginShape();
    // jeder Vertex muss in die Pixelposition umgerechnet werden... 
    for (int i = 0; i < pS1.getVertexCount(); i++) {
      Vec2 v1 = box2d.vectorWorldToPixels(pS1.getVertex(i));
      vertex(v1.x, v1.y);
    }
    endShape(CLOSE);
    
    popMatrix();
  }
}